class model.Post
  @author model.Author
  @title String
  @text Text
  @created_at CreatedAt


get '/': ->
  @posts = Post.find().order(created_at: 'desc').limit(5).go ->
    render 'index'


get '/:year/:month/:day': ->
  date = "#{params.year}-#{params.month}-#{params.day}"
  @posts = Post.find(created_at: date).order(created_at: 'desc').go =>
    render 'index'


layout ->
  doctype 5
  html ->
    head ->
      title 'My Blog'
    body ->
      h1 'My Blog'
      text @body


layout 'admin': ->
  doctype 5
  html ->
    head ->
      title 'My Blog | Admin'
    body ->
      h1 'My Blog | Admin'
      text @body

view 'index': ->
  for post in @posts
    article ->
      h1 post.title
      text post.text
  section ->
    h1 'Comments'
    for comment in post.comments
