# Server

get
  '/': ->
    redirect '/login' unless session.username?
    render 'index'

  '/login': ->
    render 'login'

  '/logout': ->
    delete session.username
    redirect '/login'

post '/login': ->
  session.username = @username
  redirect '/'

msg say: ->
  broadcast 'said', id: @id, text: @text

# Client

client 'jquery', 'socket.io'

client
  login: ->
    $('#username').focus()

  index: ->
    msg someone_said: ->
      $('#messages').append "<p>#{@id} said: #{@text}</p>"

    $('#say').click ->
      send 'say', text: $('#input').val()
      $('#input').val('').focus()

# Views

view login: ->
  @title = 'Log In'
  @script = 'login'
  form action: '/login', method: 'post', ->
    input id: 'username', name: 'username'
    button 'Log In'

view index: ->
  @title = 'Home'
  @script = 'index'
  div id: 'messages'
  input id: 'input'
  button id: 'say'

layout default: ->
  doctype 5
  html ->
    head ->
      title @home
      script src: 'http://code.jquery.com/jquery-1.4.3.min.js'
      script(src: "/#{@script}.js") if @script?
      style 'body {font-family: sans-serif; color: #eee; background-color: #333}'
    body -> @body
