#!/usr/bin/env coffee

zappa = require 'zappa'

OptionParser = require('coffee-script/optparse').OptionParser
fs = require 'fs'
exec = require('child_process').exec

package_root = fs.realpathSync(__filename.replace ' (compiled)', '')
app_root = process.cwd()

usage = '''
  Usage:
    zappa COMMAND [ARGS]

  Commands:
    version, --version, -v: shows zappa version
    run FILE [PORT]: runs the app
'''

options = [
  ['-e', '--environment [NAME]', '']
  ['-p', '--port [NUMBER]', '']
]

args = process.argv.slice(0)
command = args.shift()

parser = new OptionParser options, usage
params = parser.parse args

if not command? then puts usage
else if command is 'version'
  puts zappa.version
else if command is 'run'
  process.env['ZAPPA_ENV'] = if params.environment? then params.environment
  port = if params.port? then parseInt(params.port)
  path = fs.realpathSync args[0]
  zappa.run_file path
else puts usage
