get '/': -> render 'default'

get '/counter': -> "# of messages so far: #{app.counter}"

at connection: ->
  app.counter ?= 0
  puts "Connected: #{id}"
  broadcast 'connected', id: id

at disconnection: ->
  puts "Disconnected: #{id}"

msg said: ->
  puts "#{id} said: #{@text}"
  app.counter++
  send 'said', id: id, text: @text
  broadcast 'said', id: id, text: @text

client ->
  at connection: ->
    $('#log').append '<p>Connected</p>'
  
  at disconnection: ->
    $('#log').append '<p>Disconnected</p>'

  msg connected: ->
    $('#log').append "<p>#{id} Connected</p>"

  msg said: ->
    $('#log').append "<p>#{id}: #{@text}</p>"

  $('form').submit ->
    send 'said', text: $('#box').val()
    $('#box').val('').focus()
    false

  connect()
  $('#box').focus()

view ->
  @title = 'Nano Chat'
  @scripts = ['http://code.jquery.com/jquery-1.4.3.min', 'http://cdn.socket.io/stable/socket.io', 'default']

  h1 @title
  div id: 'log'
  form ->
    input id: 'box'
    button id: 'say', -> 'Say'
